/*
 *  $Id$
 */

/*
 * FreeWnn is a network-extensible Kana-to-Kanji conversion system.
 * This file is part of FreeWnn.
 * 
 * Copyright Kyoto University Research Institute for Mathematical Sciences
 *                 1987, 1988, 1989, 1990, 1991, 1992
 * Copyright OMRON Corporation. 1987, 1988, 1989, 1990, 1991, 1992, 1999
 * Copyright ASTEC, Inc. 1987, 1988, 1989, 1990, 1991, 1992
 * Copyright FreeWnn Project 1999, 2000
 *
 * Maintainer:  FreeWnn Project   <freewnn@tomo.gr.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef WNN_WNNERROR_H
#define WNN_WNNERROR_H

/* file طΥ顼 */
#define WNN_FILE_READ_ERROR     90      /* եɤ߹ळȤǤޤ */
#define WNN_FILE_WRITE_ERROR    91      /* ե񤭽ФȤǤޤ */
#define WNN_FID_ERROR           92      /* 饤Ȥɤ߹եǤϤޤ */
#define WNN_NO_MORE_FILE        93      /* ʾեɤ߹ळȤǤޤ */
#define WNN_INCORRECT_PASSWD    94      /* ѥɤְäƤޤ */
#define WNN_FILE_IN_USE         95      /* ե뤬ɤ߹ޤƤޤ */
#define WNN_UNLINK              96      /* ե뤬Ǥޤ */
#define WNN_FILE_CREATE_ERROR   97      /* ե뤬ޤ */
#define WNN_NOT_A_FILE          98      /*ףΥեǤޤ */
#define WNN_INODE_CHECK_ERROR   99      /* եI-nodeFILE_UNIQפǤޤ */

/*      V3      */
/* ɲôطΥ顼 */
#define WNN_NO_EXIST            1       /*ե뤬¸ߤޤ */
#define WNN_MALLOC_ERR          3       /*allocǼԤޤ */
#define WNN_NOT_A_DICT          5       /*ǤϤޤ */
#define WNN_NOT_A_HINDO_FILE    6       /*٥եǤϤޤ */
#define WNN_NOT_A_FUZOKUGO_FILE 7       /*°եǤϤޤ */
#define WNN_JISHOTABLE_FULL     9       /*ơ֥뤬դǤ */
#define WNN_HINDO_NO_MATCH      10      /*٥ե뤬ꤵ줿
                                           ٥եǤϤޤ */
#define WNN_OPENF_ERR           16      /*ե뤬ץǤޤ */
#define WNN_NOT_HINDO_FILE      17      /*٥եǤޤ */
#define WNN_NOT_FZK_FILE        18      /*°եǤޤ */
#define WNN_FZK_TOO_DEF         19      /*°θĿ٥Ĺʤɤ
                                           ¿᤮ޤ */
/* طΥ顼 */
#define WNN_DICT_NOT_USED       20      /*ֹμϡȤƤޤ */

/* ѴΥ顼 */
#define WNN_BAD_FZK_FILE  24    /*°եƤޤ */
#define WNN_GIJI_HINSI_ERR      25      /*ʻֹ椬۾Ǥ
                                           hinsi.dataޤ */
#define WNN_NO_DFE_HINSI        26      /*̤ʻ줬üʻȤ
                                           Ƥޤ Not Used */
#define WNN_FZK_FILE_NO_LOAD    27      /*°ե뤬ɤ߹ޤƤޤ */

/* jishobiki.c */
#define WNN_DIC_ENTRY_FULL      30      /*Υȥ꤬¿᤮ޤ */
#define WNN_LONG_MOJIRETSU      31      /*Ѵ褦ȤʸĹ᤮ޤ */
#define WNN_WKAREA_FULL         32      /*°ΰ褬­Ƥޤ */
#define WNN_JKTAREA_FULL        34      /*ΰ褬­Ƥޤ */
#define WNN_NO_KOUHO            35      /*䤬 1 ĤޤǤ */

/* ñϿΥ顼 */
#define WNN_YOMI_LONG           40      /*ɤߤĹ᤮ޤ */
#define WNN_KANJI_LONG          41      /*Ĺ᤮ޤ */
#define WNN_NOT_A_UD            42      /*ꤵ줿ϡϿǽǤϤޤ */
#define WNN_NO_YOMI             43      /*ɤߤĹ0Ǥ */
#define WNN_NOT_A_REV           44      /*ꤵ줿ϡհǽǤϤޤ */
#define WNN_RDONLY              45      /*꡼ɥ꡼μϿ褦Ȥޤ */
#define WNN_DICT_NOT_IN_ENV     46      /*Ķ¸ߤʤϿ褦Ȥޤ */

/* ٹΥ顼 */
#define WNN_RDONLY_HINDO        49      /* ꡼ɥ꡼٤ѹ褦Ȥޤ */

/* ñʻΥ顼 */
/*
WNN_RDONLY
*/
#define WNN_WORD_NO_EXIST       50      /*ꤵ줿ñ줬¸ߤޤ */

/* λΥ顼 */
#define WNN_MALLOC_INITIALIZE   60      /*allocǼԤޤ */

#define WNN_SOME_ERROR          68      /* Υ顼ޤ */
#define WNN_SONOTA              69      /*ХȯƤͤǤNot Used */
#define WNN_JSERVER_DEAD        70      /*ФǤޤ(jlib) */
#define WNN_ALLOC_FAIL          71      /*alloc˼(jlib) */
#define WNN_SOCK_OPEN_FAIL      72      /*jd_beginsocketopen˼(jlib) */
#define WNN_BAD_VERSION         73      /*̿ץȥΥС󤬹äƤޤ */
#define WNN_BAD_ENV             74      /*饤ȤĶǤϤޤ */

#define WNN_MKDIR_FAIL          80      /* ǥ쥯ȥ»ʤä */


/*ʻե */
#define WNN_TOO_BIG_HINSI_FILE 100      /*ʻե뤬礭᤮ޤ */
#define WNN_TOO_LONG_HINSI_FILE_LINE 101        /*ʻե뤬礭᤮ޤ */
#define WNN_NO_HINSI_DATA_FILE 102      /*ʻե뤬¸ߤޤ */
#define WNN_BAD_HINSI_FILE 103  /*ʻեƤְäƤޤ */

#define WNN_HINSI_NOT_LOADED 105        /* ʻե뤬ɤ߹ޤƤޤ */
#define WNN_BAD_HINSI_NAME 106  /* ʻְ̾äƤޤ */
#define WNN_BAD_HINSI_NO 107    /* ʻֹ椬ְäƤޤ */

#define NOT_SUPPORTED_OPERATION 109     /*ϥݡȤƤޤNot Used */

/* 
 *
 *  jl ʹ饤֥ˤΥ顼
 * 
 */

#define WNN_CANT_OPEN_PASSWD_FILE 110   /* ѥɤäƤե뤬
                                           ץǤޤ(jl) */
/* Υ顼  */
#define WNN_RC_FILE_NO_EXIST 111        /* uumrcե뤬¸ߤޤ(jl) Not Used */
#define WNN_RC_FILE_BAD_FORMAT 112      /* uumrcեηäƤޤ(jl)Not Used */
#define WNN_NO_MORE_ENVS  113   /* ʾĶ뤳ȤϽޤ */
#define WNN_FILE_NOT_READ_FROM_CLIENT 114       /* Υ饤Ȥɤ߹եǤޤ */
#define WNN_NO_HINDO_FILE 115   /* ٥ե뤬ĤƤޤ */

#define WNN_CANT_CREATE_PASSWD_FILE 116 /*ѥɤΥե뤬ޤ */

#endif  /* WNN_WNNERROR_H */
